#URL:		https://github.com/RinCat/RTL88x2BU-Linux-Driver.git
# git clone https://github.com/RinCat/RTL88x2BU-Linux-Driver.git 
###
%define gitname rtl88x2bu
%global	module	88x2bu
%global pname rtl%{module}
#%global lname %{pname}-legacy

Name:		dkms-%{pname}
Version:	5.8.7.1
Release:	%mkrel 1
Source0:	%{gitname}-%{version}.tar.xz

#Patch0:		rtl88x2bu-makefile.patch
Patch0:		rtl88x2bu-5.8.7.1-makefile.patch

License:	GPLv2
Group:		System/Kernel and hardware

URL:		https://github.com/cilynx/
Summary:	dkms package for realtek 8812bu+8822bu driver
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

Provides:	kmod(%{module}.ko) = %{version}
Requires(post):		dkms
Requires(preun):	dkms

Obsoletes:	dkms-%{pname} < %{version}-%{release}
Obsoletes:	dkms-rtl8822bu

%description
Current Driver Version: 5.8.7.1
5.8.7.1_35809.20191129_COEX20191120-7777
Support Kernel: 2.6.24 ~ 5.8 (with unofficial patches)
Official release note please check ReleaseNotes.pdf
Note: if you believe your device is RTL8812BU or RTL8822BU but after loaded
the module no NIC shows up, the device ID maybe not in the driver whitelist.
In this case please submit a new issue with lsusb result, and your device name,
brand, website, etc.

Realtek provides the solution for WLAN in hardware and software.
The software package could be adopted for Realtek RTL88x2B USB WLAN series
hardware on Linux based platforms.

Software Version:
RTL88x2B USB Linux Driver Version: v5.6.1.6_35492.20191025_COEX20180928-6a6a
Software Package Feature:
IEEE 802.11 b/g/n/ac WiFi compliant
802.1x, WEP, WPA TKIP andWPA2 AES/Mixed mode for PSK and TLS (Radius)
WPA3-SAE Personal
WPS - PIN and PBC Methods
IEEE 802.11b/g/n/ac Client mode
- Support wireless security for WEP, WPA TKIP and WPA2 AES PSK
- Support site survey scan and manual connect
- Support WPA/WPA2 TLS client
- Support power saving mode
Soft AP mode
WiFi-Direct
Hardware Supported:
RTL8812BU and RTL8822BU
	ASUS AC1300 USB-AC55 B1
    ASUS U2
    Dlink - DWA-181
    Dlink - DWA-182
    Edimax EW-7822ULC
    Edimax EW-7822UTC
    NetGear A6150
    TP-Link Archer T3U
    TP-Link Archer T3U Plus
    TP-Link Archer T4U V3
    TRENDnet TEW-808UBM
and more
/*=== Realtek demoboard ===*/
{USB_DEVICE_AND_INTERFACE_INFO(USB_VENDER_ID_REALTEK, 0xB82C, ...
_info = RTL8822B}, /* Default ID for USB multi-function */
{USB_DEVICE_AND_INTERFACE_INFO(USB_VENDER_ID_REALTEK, 0xB812, ...
_info = RTL8822B}, /* Default ID for USB Single-function, WiFi only */
/*=== Customer ID ===*/
{USB_DEVICE_AND_INTERFACE_INFO(0x13b1, 0x0043, ... /* Alpha - Alpha*/
{USB_DEVICE_AND_INTERFACE_INFO(0x0b05, 0x1841, ... /* ASUS AC1300 USB-AC55 B1 */
{USB_DEVICE_AND_INTERFACE_INFO(0x0b05, 0x184C, ... /* ASUS U2*/
{USB_DEVICE_AND_INTERFACE_INFO(0x7392, 0xB822, ... /* Edimax EW-7822ULC */
{USB_DEVICE_AND_INTERFACE_INFO(0x7392, 0xC822, ... /* Edimax EW-7822UTC */
{USB_DEVICE_AND_INTERFACE_INFO(0x2001, 0x331e, ... /* Dlink - DWA-181*/
{USB_DEVICE_AND_INTERFACE_INFO(0x2001, 0x331c, ... /* Dlink - DWA-182*/
{USB_DEVICE_AND_INTERFACE_INFO(0x0846, 0x9055, ... /* NetGear A6150 */
{USB_DEVICE_AND_INTERFACE_INFO(0x2357, 0x012D, ... /* TP-Link Archer T3U */
{USB_DEVICE_AND_INTERFACE_INFO(0x2357, 0x0138, ... /* TP-Link Archer T3U Plus */
{USB_DEVICE_AND_INTERFACE_INFO(0x2357, 0x0115, ... /* TP-Link Archer T4U V3 */
{USB_DEVICE_AND_INTERFACE_INFO(0x20F4, 0x808A, ... /* TRENDnet TEW-808UBM */

%prep
%setup -qn %{gitname}-%{version}
find -type f -exec chmod 0644 {} \;

%apply_patches

%install
%__rm -rf %{buildroot}
#%__install -dm755 %{buildroot}/lib/firmware
%__install -dm755 %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
%__cp -a . %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
#%__mv -f %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/regdb/* %{buildroot}/lib/firmware/
#%__rm -f %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/{CONTRIBUTORS.md,LICENSE,README.md}
%__cat <<EOF > %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/dkms.conf
PACKAGE_NAME="%{pname}"
PACKAGE_VERSION="%{version}-%{release}"
BUILT_MODULE_NAME="rtl%{module}"
BUILT_MODULE_LOCATION="./"
MAKE="'make' SKIP_STACK_VALIDATION=1 all"
CLEAN="'make' clean"
DEST_MODULE_LOCATION="/kernel/3rdparty/%{pname}"
AUTOINSTALL="yes"
EOF

%post -n %{name}
/sbin/modprobe -r rtl8822bu >/dev/null 2>&1
sed -i '/rtl8822bu/ d' /etc/modprobe.preload 2>&1
/usr/sbin/dkms --rpm_safe_upgrade add -m %{pname} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade build -m %{pname} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade install -m %{pname} -v %{version}-%{release}

if [ "$1" = 1 ]; then
if [ -f /etc/NetworkManager/NetworkManager.conf ]; then
randmacad=`grep "wifi.scan-rand-mac-address=no" /etc/NetworkManager/NetworkManager.conf`
fi
if [ "$randmacad" = z ]; then
cat <<EOF > /etc/NetworkManager/NetworkManager.conf
[device]
wifi.scan-rand-mac-address=no
EOF
fi

/sbin/modprobe %{pname} >/dev/null 2>&1
echo "Reloading network configuration ... "
/sbin/service network reload >/dev/null 2>&1
echo "%{pname}" >> /etc/modprobe.preload
fi

###rm -rf /lib/modules/*/kernel/3rdparty/%{pname} >/dev/null 2>&1

%preun -n %{name}
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{pname} -v %{version}-%{release} --all

if [ "$1" = 0 ]; then
/sbin/rmmod %{pname} >/dev/null 2>&1
echo "Reloading network configuration ... "
/sbin/service network reload >/dev/null 2>&1
sed -i '/%{pname}/ d' /etc/modprobe.preload
fi
## remove module-destdir just if it empty after dkms remove,(user's only deinstall after testing)... ##
## so prevent we not have empty folders in kernel-tree for next mklivecd ##
if [ ! -f /lib/modules/*/kernel/3rdparty/%{pname}/* ]; then
rm -r /lib/modules/*/kernel/3rdparty/%{pname} >/dev/null 2>&1
fi

%clean
%__rm -rf %{buildroot}

%files
#%doc README.md Realtek_Changelog.txt
##CONTRIBUTORS.md LICENSE 
%defattr(-,root,root)
%{_usrsrc}/%{pname}-%{version}-%{release}
#/lib/firmware/*


%changelog
* Tue Aug 25 2020 onkelho <oh.quait at gmail.com> - 5.8.7.1-1pclos2020
- new version-release 
- add TRENDnet TEW-808UBM

* Sun Aug 02 2020 onkelho <oh.quait at gmail.com> - 5.6.1.6-1pclos2020
- new version-release 
- fix handling on newer rtw-cores, ...
- obsoletes old rtl8822bu
- testing



